package demo.gridbag;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridBagLayoutInfo;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;

public class TotallyGridBagDemo extends JFrame
{
  public static void main(String[] args) throws Exception
  {
    //set minimum rootpane size - do not respect minimum component sizes
    //UIManager.put("Synthetica.rootPane.minimumWindowSize", new java.awt.Dimension(100,100));
    UIManager.setLookAndFeel("de.javasoft.plaf.synthetica.SyntheticaStandardLookAndFeel");
    SwingUtilities.invokeLater(new Runnable()
    {      
      public void run()
      {
        new TotallyGridBagDemo();
      }
    });
  }

  public TotallyGridBagDemo()
  {
    JTextField nameField = new JTextField(20);
    JTextField ageField = new JTextField(3);
    JComboBox colorCombo = new JComboBox(new String[]{"Red", "Green", "Blue", "Orange"});
    JButton okayButton = new JButton("OK");
    JButton cancelButton = new JButton("Cancel");
    JTextArea textArea = new JTextArea(3, 20);
    JScrollPane noteScroller = new JScrollPane(textArea);
    
    Container cp = getContentPane();
    cp.setLayout(new PreferredGridBagLayout());
        
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.weightx = 1;
    gbc.weighty = 1;
    gbc.insets = new Insets(4,4,0,4);
    gbc.anchor = GridBagConstraints.WEST;
    //gbc.fill = GridBagConstraints.BOTH;
    
    JLabel label = new JLabel("Name");
    cp.add(label, gbc);
 
    gbc.gridx++;
    cp.add(nameField, gbc);

    gbc.gridx = 0;
    gbc.gridy++;
    JLabel age = new JLabel("Age");
    cp.add(age, gbc);
    
    gbc.gridx++;
    cp.add(ageField, gbc);
    
    gbc.gridx = 0;
    gbc.gridy++;
    JLabel color = new JLabel("Fav Colour");
    cp.add(color, gbc);
    
    gbc.gridx++;
    cp.add(colorCombo, gbc);

    gbc.gridx = 0;
    gbc.gridy++;
    gbc.anchor = GridBagConstraints.NORTHWEST;
    JLabel note = new JLabel("Note");
    int top = noteScroller.getInsets().top + textArea.getInsets().top;
    Insets ins = note.getInsets();
    note.setBorder(new EmptyBorder(top, ins.left, ins.bottom, ins.right));
    cp.add(note, gbc);
    
    gbc.gridx++;
    cp.add(noteScroller, gbc);
          
    gbc.gridx = 0;
    gbc.gridy++;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.anchor = GridBagConstraints.EAST;
    
    Container buttons = new JPanel(new GridBagLayout());
    GridBagConstraints gbc2 = new GridBagConstraints();
    gbc2.gridx = 0;
    gbc2.gridy = 0;
    gbc2.insets = new Insets(8,4,8,0);
    buttons.add(okayButton, gbc2);
    gbc2.gridx++;
    gbc2.gridwidth = GridBagConstraints.REMAINDER;
    buttons.add(cancelButton, gbc2);    
    cp.add(buttons, gbc);
    
    setTitle(getClass().getSimpleName());
    setDefaultCloseOperation(EXIT_ON_CLOSE);    
    pack();
    setLocationRelativeTo(null);
    setVisible(true);    
  }
  
  private static class PreferredGridBagLayout extends GridBagLayout
  {
    @Override
    protected GridBagLayoutInfo getLayoutInfo(Container parent, int sizeflag)
    {
      return super.getLayoutInfo(parent, PREFERREDSIZE);
    }
  }
}
